// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITFILTER_H
#define GITFILTER_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
#include <git2/sys/filter.h>
}

#include "../include/typedefs.h"


using namespace node;
using namespace v8;

class GitFilter;

struct GitFilterTraits {
  typedef GitFilter cppClass;
  typedef git_filter cType;

  static const bool isDuplicable = false;
  static void duplicate(git_filter **dest, git_filter *src) {
    Nan::ThrowError("duplicate called on GitFilter which cannot be duplicated");
  }

  static const bool isFreeable = true;
  static void free(git_filter *raw) {
    ::free(raw); // :: to avoid calling this free recursively
  }
};

class GitFilter : public
  NodeGitWrapper<GitFilterTraits> {
  // grant full access to base class
  friend class NodeGitWrapper<GitFilterTraits>;
public:
  static void InitializeComponent (v8::Local<v8::Object> target);



private:
  GitFilter()
    : NodeGitWrapper<GitFilterTraits>(
        "A new GitFilter cannot be instantiated."
      )
  {}
  GitFilter(git_filter *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
    : NodeGitWrapper<GitFilterTraits>(raw, selfFreeing, owner)
  {}
  ~GitFilter();
  static NAN_METHOD(Version);
  static NAN_METHOD(Attributes);
};

#endif
